package com.pqs9900.serviceImpl.HisData;

import com.pqs9900.mapper.HisData.DataPltMapper;
import com.pqs9900.pojo.HisData.DataPlt;
import com.pqs9900.service.HisData.DataPltService;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.scheduling.concurrent.ThreadPoolTaskExecutor;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.util.ArrayList;
import java.util.List;
import java.util.concurrent.Callable;
import java.util.concurrent.Future;

/** @Author denghuajun
 * @Description //TODO 长时闪变
 * @Date  2018/12/17 10:52
 **/
@Service
public class DataPltServiceImpl implements DataPltService {

    private static final Logger logger= LoggerFactory.getLogger(DataPltServiceImpl.class);

    @Autowired
    DataPltMapper dataPltMapper;

    @Autowired
    private ThreadPoolTaskExecutor taskExecutor;

    @Override
    public int saveDataPlt(DataPlt dataPlt) {
        return dataPltMapper.insert(dataPlt);
    }

    @Override
    @Transactional(rollbackFor = Exception.class)
    public int insertDataPlt(List<DataPlt> list) {
        return dataPltMapper.insertDataPlt(list);
    }

    /**
     * 采用线程池进行数据入库
     * @param listDataPlt  长时闪变数据
     */
    @Override
    public Future insertDataPltExecutor(List<DataPlt> listDataPlt) {
        int inum = 100 ;//每次解析入库条目数
        Callable callable = new Callable() {
            @Override
            public Object call() throws Exception {
                int nCyclicTimes;//循环次数（总长度/批量入库条目数）
                int fromIndex,toIndex;//获取数据的起始和结束下标
                try {
                    nCyclicTimes = (int) Math.ceil(listDataPlt.size() / (double) inum);
                    List<DataPlt> tmpListDataPlt = new ArrayList<>();
                    for (int i = 0; i < nCyclicTimes; i++) {
                        tmpListDataPlt.clear();
                        //假如是最后一次循环则获取循环到结束
                        fromIndex = i * inum;
                        if (i == nCyclicTimes - 1) {
                            toIndex = listDataPlt.size();
                        } else {
                            toIndex = (i + 1) * inum;
                        }
                        //可以先按下标截取，再入库
                        tmpListDataPlt.addAll(listDataPlt.subList(fromIndex, toIndex));
                        // TODO 做批量入库的操作
                        dataPltMapper.insertDataPlt(tmpListDataPlt);
                    }
                    return "SUCCESS";
                } catch (Exception e) {
                    logger.error("长时闪变导入异常，异常是" + e.toString());
                    return "FAIL";
                }
            }
        };
        return taskExecutor.submit(callable);
    }
}
